#ifndef __APP_H
#define __APP_H

#include <Application.h>
#include <Window.h>
#include <string>
#include <vector>


class CtrlView;
class PieView;
class StatusView;

class Win: public BWindow
{
    // instance variables
    public:
	CtrlView   *ctrlView;
	PieView	   *pieView;
	StatusView *statusView;

    // methods
    private:
	bool	_fixAspectRatio(float *width, float *height);

    public:
                Win(BRect pieRect);
                ~Win();

        void	MessageReceived(BMessage *m);
	void	Zoom(BPoint origin, float width, float height);
	void	FrameResized(float width, float height);
        bool    QuitRequested();
};

class App: public BApplication
{
    // instance variables
    private:
	BResources     *_resources;
	Win	       *_win;
	vector<string>	_args;

    // methods
    public:
		App();
		~App();

	void	ArgvReceived(int32 argc, char **argv);
	void	RefsReceived(BMessage *m);
	void	ReadyToRun();
	void	MessageReceived(BMessage *m);
};

#endif // __APP_H

