#ifndef __CTRL_H
#define __CTRL_H

#include <MenuItem.h>
#include <MenuField.h>
#include <Volume.h>
#include <VolumeRoster.h>
#include <NodeMonitor.h>
#include <Bitmap.h>
#include <Button.h>
#include <View.h>
#include <string>
#include "app.h"


class VolMenuItem: public BMenuItem
{
    // instance variables
    private:
	BBitmap *_icon;
	BVolume *_volume;

    // methods
    public:
		    VolMenuItem(BVolume *v, BMessage *m);
		    ~VolMenuItem();

	BVolume	   *volume() const { return _volume; }
	status_t    invoke() { return Invoke(); }

	void	    GetContentSize(float *width, float *height);
	void	    DrawContent();
};


class VolCtrl: public BMenuField
{
    // instance variables
    private:
	BVolumeRoster *_roster;

    // methods
    private:
	void	_addVolume(dev_t device);
	void	_removeVolume(dev_t device);

    public:
		VolCtrl(BRect r);
		~VolCtrl();

	BVolume *findDevice(dev_t device, bool invoke=false);

	void	AttachedToWindow();
	void	MessageReceived(BMessage *m);
};


class CtrlView: public BView
{
    // instance variables
    private:
	BButton	   *_rescanButton;

    public:
	VolCtrl	   *volCtrl; 

    // methods
    public:
                CtrlView(BRect r);
                ~CtrlView();

	void	enableRescan(bool enable) { _rescanButton->SetEnabled(enable); }
};


#endif // __CTRL_H

