#include <stdio.h>
#include "common.h"
#include "misc.h"

const char *
scaleByteCount(off_t byteCount)
{
    struct {
	off_t	limit;
	float	divisor;
	char   *format;
    } scale[] = {
	{ 0x100000,		1024.0,		    "%.2f KB" },
	{ 0x40000000,		1048576.0,	    "%.2f MB" },
	{ 0x10000000000ull,	1073741824.0,	    "%.2f GB" },
	{ 0x4000000000000ull,	1.09951162778e+12,  "%.2f TB" }
    };

    if (byteCount < 1024) {
	sprintf(strbuf, "%lld bytes", byteCount);
    }
    else {
	int i = 0;
	while (byteCount >= scale[i].limit) {
	    i++;
	}
	sprintf(strbuf, scale[i].format, byteCount / scale[i].divisor);
    }

    return strbuf;
}

