#include <Application.h>
#include <Roster.h>
#include <Path.h>
#include <Alert.h>

#include <stdio.h>

#define __RES_CPP
#include "res.h"


BResources *
readResources(const char *appSignature)
{
    if (be_app->GetAppInfo(&kAppInfo) != B_OK) {
	exit(1);
    }
    
    BFile file(&kAppInfo.ref, O_RDONLY);
    if (file.InitCheck() != B_NO_ERROR) {
	exit(1);
    }

    BResources *r = new BResources(&file);

#define LoadString(n)	(char*)r->LoadResource(B_STRING_TYPE, n, &ignore)
#define LoadColor(n)	*(rgb_color*)r->LoadResource(B_RGB_COLOR_TYPE, n, &ignore)
#define LoadUint8(n)	*(uint8*)r->LoadResource(B_UINT8_TYPE, n, &ignore)

    size_t ignore;
    kVolMenuLabel = LoadString("STR_VM_LABEL");
    kOneFile = LoadString("STR_1_FILE");
    kManyFiles = LoadString("STR_N_FILES");
    kStrRescan = LoadString("STR_RESCAN");
    kStrScanningX = LoadString("STR_SCN_X");
    kStrUnavail = LoadString("STR_UNAVAIL");
    kVolMenuDefault = LoadString("STR_VM_DFLT");
    kVolPrompt = LoadString("STR_VPROMPT");
    kMenuGetInfo = LoadString("STR_M_INFO");
    kMenuOpen = LoadString("STR_M_OPEN");
    kMenuOpenWith = LoadString("STR_M_OPENW");
    kMenuNoApps = LoadString("STR_M_NAPPS");
    kInfoSize = LoadString("STR_SIZE");
    kInfoInFiles = LoadString("STR_INFILES");
    kInfoCreated = LoadString("STR_MADE");
    kInfoModified = LoadString("STR_MOD");
    kInfoTimeFmt = LoadString("STR_TIMEFMT");
    kInfoKind = LoadString("STR_KIND");
    kInfoPath = LoadString("STR_PATH");

    kWindowColor = LoadColor("RGB_WIN");
    kOutlineColor = LoadColor("RGB_PIE_OL");
    kPieBGColor = LoadColor("RGB_PIE_BG");
    kEmptySpcColor = LoadColor("RGB_PIE_MT");

    kBasePieColorCount = LoadUint8("N_PIE_COLORS");
    kBasePieColor = new rgb_color[kBasePieColorCount];
    for (int i = 0; i < kBasePieColorCount; i++) {
	char colorName[16] = "RGB_PIE_n";
	colorName[8] = '1' + i;
	kBasePieColor[i] = LoadColor(colorName);
    }

    // Get a reference to the help file.
    BEntry entry(&kAppInfo.ref);
    BPath path1, path2;
    entry.GetPath(&path1);
    path1.GetParent(&path2);
    path2.Append(kHelpFileName);
    printf("help file =? %s\n", path2.Path());
    entry.SetTo(path2.Path());
    struct stat st;
    kFoundHelpFile = (entry.GetStat(&st) == B_OK);
    entry.GetRef(&kHelpFileRef);

    return r;
}

