#ifndef __RES_H
#define __RES_H

#include <Resources.h>
#include <GraphicsDefs.h>
#include <Entry.h>


#ifdef __RES_CPP
#   define EXTERN
#   define EQ(x) =x
#else
#   define EXTERN extern
#   define EQ(x)
#endif

#define PUBLIC_CONST extern const


// Resources
EXTERN char *kStrRescan;
EXTERN char *kStrScanningX;
EXTERN char *kStrUnavail;
EXTERN char *kVolMenuLabel;
EXTERN char *kVolMenuDefault;
EXTERN char *kVolPrompt;
EXTERN char *kOneFile;
EXTERN char *kManyFiles;
EXTERN char *kMenuGetInfo;
EXTERN char *kMenuOpen;
EXTERN char *kMenuOpenWith;
EXTERN char *kMenuNoApps;
EXTERN char *kInfoSize;
EXTERN char *kInfoInFiles;
EXTERN char *kInfoCreated;
EXTERN char *kInfoModified;
EXTERN char *kInfoTimeFmt;
EXTERN char *kInfoKind;
EXTERN char *kInfoPath;

EXTERN rgb_color kWindowColor;
EXTERN rgb_color kOutlineColor;
EXTERN rgb_color kPieBGColor;
EXTERN rgb_color kEmptySpcColor;
EXTERN int kBasePieColorCount;
EXTERN rgb_color *kBasePieColor;

// Non-resources :)
PUBLIC_CONST char *kGuidoSig EQ("application/x-vnd.msteed-guido");
PUBLIC_CONST char *kHelpFileName EQ("guido.html");
PUBLIC_CONST char *kPieRectAttrName EQ("mainrect");

PUBLIC_CONST char *kHelpBtnLabel EQ("?");
PUBLIC_CONST char *kEmptyStr EQ("");
PUBLIC_CONST char *kNameVolPtr EQ("vol");
PUBLIC_CONST char *kNameFilePtr EQ("file");

PUBLIC_CONST float kSmallHMargin EQ(5.0);
PUBLIC_CONST float kSmallVMargin EQ(2.0);
PUBLIC_CONST float kButtonMargin EQ(20.0);
PUBLIC_CONST float kMinButtonWidth EQ(60.0);

PUBLIC_CONST float kProgBarWidth EQ(150.0);
PUBLIC_CONST float kProgBarHeight EQ(16.0);
PUBLIC_CONST float kReportInterval EQ(2.5);

PUBLIC_CONST float kDefaultPieSize EQ(400.0);
PUBLIC_CONST float kPieCenterSize EQ(80.0);
PUBLIC_CONST float kPieRingSize EQ(20.0);
PUBLIC_CONST float kPieInnerMargin EQ(10.0);
PUBLIC_CONST float kPieOuterMargin EQ(10.0);
PUBLIC_CONST float kMinSegmentSpan EQ(2.0);
PUBLIC_CONST int kLightenFactor EQ(0x12);
PUBLIC_CONST float kDragThreshold EQ(5.0);

EXTERN app_info kAppInfo;
EXTERN entry_ref kHelpFileRef;
EXTERN bool kFoundHelpFile;

// For temporary string work.
EXTERN char strbuf[512];


BResources *readResources(const char *appSignature);

#endif // __RES_H

