#ifndef __SCANNER_H
#define __SCANNER_H

#include <Looper.h>
#include <string>
#include "snapshot.h"


class Scanner: public BLooper
{
    // instance variables
    private:
	BMessenger     *_messenger;
	BMessage       *_doneMsg;
	BMessage       *_progressMsg;
	BVolume	       *_volume;
	off_t		_volBytesInUse;
	off_t		_volBytesScanned;
	float		_progress;
	float		_lastReport;
	VolSnapshot    *_snapshot;
	string		_desiredPath;
	string		_task;
	bool		_busy;
	bool		_quitRequested;

    // methods
    private:
	void	    _refresh(FileInfo *startInfo);
	FileInfo   *_getFileInfo(BDirectory *dir, FileInfo *parent);
	void	    _changeToDesired();

    public:
		    Scanner(BVolume *v, BHandler *handler);
		    ~Scanner();

	VolSnapshot *snapshot() { return _busy ? NULL : _snapshot; }
	void	    refresh(FileInfo *startInfo=NULL);
	bool	    busy() { return _busy; }
	const char *task() { return _task.c_str(); }
	float	    progress() { return (_progress > 100.0) ? 100.0 : _progress; }
	FileInfo   *currentDir() { return _busy ? NULL : _snapshot->currentDir; }
	void	    changeDir(FileInfo *f) { _snapshot->currentDir = f; }
	void	    setDesiredPath(string &path);
	dev_t	    device() { return _volume->Device(); }
	void	    requestQuit();

	void	    MessageReceived(BMessage *m);
};


#endif // __SCANNER_H

