#ifndef __SNAPSHOT_H
#define __SNAPSHOT_H

#include <Volume.h>
#include <Directory.h>
#include <Mime.h>
#include <string>
#include <vector>


struct FileInfo
{
		FileInfo();
		~FileInfo();

    void	getPath(string &path);
    FileInfo   *findChild(const char *name);
    BMimeType  *type();

    bool	pseudo;
    entry_ref	ref;
    off_t	size;
    int		count;
    FileInfo   *parent;
    vector<FileInfo *> children;
};


struct VolSnapshot
{
		VolSnapshot(BVolume *v);
		~VolSnapshot();

    string	name;
    off_t	capacity;
    off_t	freeBytes;
    FileInfo   *rootDir;
    FileInfo   *freeSpace;
    FileInfo   *currentDir;
};

#endif // __SNAPSHOT_H

